﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace AirPlaneWithRadar
{
    internal class DrawingObjectPlane : IDrawingObject
    {
        private DrawingPlain _plain;

        public DrawingObjectPlane(DrawingPlain plain)
        {
            _plain = plain;
        }
        public float Step => _plain?.Plain?.Step ?? 0;


        public void DrawningObject(Graphics g)
        {
            _plain?.DrawTransoprt(g);
        }

        public (float Left, float Right, float Top, float Bottom) GetCurrentPosition()
        {
            return _plain?.GetCurrentPosition() ?? default;
        }

        public string GetInfo() => _plain?.GetDataForSave();
        public static IDrawingObject Create(string data) => new DrawingObjectPlane(data.CreateDrawningPlain());

        public void MoveObject(Direction direction)
        {
            _plain?.MoveTransport(direction);
        }
        public DrawingPlain GetPlane => _plain;
        public void SetObject(int x, int y, int width, int height)
        {
           _plain.setPosition(x, y, width, height);
        }

        public bool Equals(IDrawingObject? other)
        {
            if (other == null)
            {
                return false;
            }
            var otherPlain = other as DrawingObjectPlane;
            if (otherPlain == null)
            {
                return false;
            }
            var plain = _plain.Plain;
            var otherPlainPlain = otherPlain._plain.Plain;

            if (plain.Speed != otherPlainPlain.Speed)
            {
                return false;
            }
            if (plain.Weight != otherPlainPlain.Weight)
            {
                return false;
            }
            if (plain.BodyColor != otherPlainPlain.BodyColor)
            {
                return false;
            }
            var RadPlain = plain as RadioPlane;
            var otherRadPlain = otherPlainPlain as RadioPlane;
            if (RadPlain == null && otherRadPlain == null)
                return true;
            if (RadPlain == null || otherRadPlain == null)
                return false;
            if (!(RadPlain.DopColor.Equals(otherRadPlain.DopColor)))
                return false;
            if (!(RadPlain.Radar.Equals(otherRadPlain.Radar)))
                return false;
            if (!(RadPlain.OilBox.Equals(otherRadPlain.OilBox)))
                return false;

            return true;
        }
    }
}
