﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace AirPlaneWithRadar
{
    internal static class ExtentionPlain
    {
        private static readonly char _separatorForObject = ':';

        public static DrawingPlain CreateDrawningPlain(this string info)
        {
            string[] strs = info.Split(_separatorForObject);
            if (strs.Length == 3)
            {
                return new DrawingPlain(Convert.ToInt32(strs[0]),
                    Convert.ToInt32(strs[1]), Color.FromName(strs[2]));
            }
            if (strs.Length == 6)
            {
                return new DrawingRadarPlane(Convert.ToInt32(strs[0]),
                    Convert.ToInt32(strs[1]), Color.FromName(strs[2]),
                    Color.FromName(strs[3]), Convert.ToBoolean(strs[4]),
                    Convert.ToBoolean(strs[5]));
            }
            return null;
        }

        public static string GetDataForSave(this DrawingPlain drawningPlain)
        {
            var plain = drawningPlain.Plain;
            var str = $"{plain.Speed}{_separatorForObject}{plain.Weight}{_separatorForObject}{plain.BodyColor.Name}";
            if (plain is not RadioPlane radioPlane)
            {
                return str;
            }
            return $"{str}{_separatorForObject}{radioPlane.DopColor.Name}{_separatorForObject}{radioPlane.Radar}{_separatorForObject}{radioPlane.OilBox}";
        }
    }
}
