﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace AirPlaneWithRadar
{
    internal class PlaneCompareByType : IComparer<IDrawingObject>
    {
        public int Compare(IDrawingObject? x, IDrawingObject? y)
        {
            if (x == null && y == null)
            {
                return 0;
            }
            if (x == null && y != null)
            {
                return 1;
            }
            if (x != null && y == null)
            {
                return -1;
            }
            var xPlain = x as DrawingObjectPlane;
            var yPlain = y as DrawingObjectPlane;
            if (xPlain == null && yPlain == null)
            {
                return 0;
            }
            if (xPlain == null && yPlain != null)
            {
                return 1;
            }
            if (xPlain != null && yPlain == null)
            {
                return -1;
            }
            if (!(xPlain.GetPlane.GetType().Name.Equals(yPlain.GetPlane.GetType().Name)))
            {
                if (xPlain.GetPlane.GetType().Name.Equals("DrawingPlain"))
                {
                    return -1;
                }
                return 1;
            }
            var speedCompare = xPlain.GetPlane.Plain.Speed.CompareTo(yPlain.GetPlane.Plain.Speed);
            if (speedCompare != 0)
            {
                return speedCompare;
            }
            return xPlain.GetPlane.Plain.Weight.CompareTo(yPlain.GetPlane.Plain.Weight);
        }
    }
}
