using Microsoft.Extensions.Configuration;
using Microsoft.Extensions.DependencyInjection;
using Microsoft.Extensions.Logging;
using NLog.Extensions.Logging;
using Serilog;
using System;

namespace AirPlaneWithRadar
{
    internal static class Program
    {

        /// <summary>
        ///  The main entry point for the application.
        /// </summary>
        [STAThread]
        static void Main()
        {


            // To customize application configuration such as set high DPI settings or default font,
            // see https://aka.ms/applicationconfiguration.
            ApplicationConfiguration.Initialize();
            var servives = new ServiceCollection();
            ConfigureServices(servives);
            using (ServiceProvider serviceProvider = servives.BuildServiceProvider())
            {
                Application.Run(serviceProvider.GetRequiredService<FormMapWithSetPlains>());
            }
        }
        private static void ConfigureServices(ServiceCollection services)
        {

            services.AddSingleton<FormMapWithSetPlains>()
                    .AddLogging(option =>
                    {
                        var configuration = new ConfigurationBuilder()
                        .AddJsonFile("C:\\Users\\\\source\\repos\\ProjectAirPlaneWithRadar\\AirPlaneWithRadar\\AirPlaneWithRadar\\appsettings.json")
                        .Build();

                        var Logger = new LoggerConfiguration()
                             .ReadFrom.Configuration(configuration)
                             .CreateLogger();


                        option.SetMinimumLevel(LogLevel.Information);
                        option.AddSerilog(Logger);
                    });
        }
    }
}